unit ExShellLinkUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  SxShellLink, StdCtrls, ComCtrls, SxConst;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    eArguments: TEdit;
    eDescription: TEdit;
    eHotKey: THotKey;
    eIconLocation: TEdit;
    eIconIndex: TEdit;
    ePath: TEdit;
    eShowCmd: TComboBox;
    eWorkingDirectory: TEdit;
    UpDown1: TUpDown;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    ShellLink: TSxWinShellLink;
    Button4: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure AssignValues;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

{ TForm1 }

procedure TForm1.AssignValues;
begin
  eArguments.Text:=ShellLink.Arguments;
  eDescription.Text:=ShellLink.Description;
  eHotKey.HotKey:=ShellLink.HotKey;
  eHotKey.Modifiers:=ShellLink.Modifiers;
  eIconLocation.Text:=ShellLink.IconLocationPath;
  eIconIndex.Text:=IntToStr(ShellLink.IconLocationIndex);
  ePath.Text:=ShellLink.Path;
  eShowCmd.ItemIndex:=Integer(ShellLink.ShowCmd);
  eWorkingDirectory.Text:=ShellLink.WorkingDirectory;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  ShellLink.New;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  ShellLink.New;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if OpenDialog.Execute then
     ShellLink.LoadFromFile(OpenDialog.Filename);
  AssignValues;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  ShellLink.Arguments:=eArguments.Text;
  ShellLink.Description:=eDescription.Text;
  ShellLink.HotKey:=eHotKey.HotKey;
  ShellLink.Modifiers:=eHotKey.Modifiers;
  ShellLink.IconLocationPath:=eIconLocation.Text;
  ShellLink.IconLocationIndex:=StrToInt(eIconIndex.Text);
  ShellLink.Path:=ePath.Text;
  ShellLink.ShowCmd:=TSxShowCmd(eShowCmd.ItemIndex);
  ShellLink.WorkingDirectory:=eWorkingDirectory.Text;
  if SaveDialog.Execute then
     ShellLink.SaveToFile(SaveDialog.Filename);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  if ShellLink.Resolve(Handle,[]) then
  begin
    AssignValues;
    ShowMessage('Resolve OK')
  end
  else
     ShowMessage('Resolve Failed');
end;

end.
